# toolkit-native

## Format Swift code automatically

```
./format
```

## Authenticate Toolkit running inside of Xcode

When Toolkit opens `https://toolkit.ai/link`, copy the `toolkit://...` link that is shown on that page.
Then:

```
defaults write ai.toolkit.mac ToolkitLinkURL "toolkit://..."
```

Now restart Toolkit.
Instead of showing you the authentication modal, Toolkit should use that URL to authenticate.
There is no need to delete the `ToolkitLinkURL` entry because Toolkit only uses it if you are unauthenticated.
If you need to reauthenticate, for example because the authentication link expired, use:

```
defaults delete ai.toolkit.mac ToolkitLinkURL
```

## Release an update using Sparkle 

```
# 1. Follow the instructions at the top of bin/make-release to set up your
# computer.

# 2. Make a release. This assumes you have checked out the web repository to
# ../toolkit.ai.
bin/make-release

# 3. Make a commit and PR in toolkit.ai that includes the new release.
cd ../toolkit.ai
git add ...
git commit ...
```

### Dequarantine the Sparkle binaries

```
find bin/sparkle -exec sudo xattr -dr com.apple.quarantine {} \;
```

### Setup the Sparkle signing key

1. Copy the ed25519 key from 1Password in the "Private key for signing Sparkle updates" entry into a new file, `~/.ssh/toolkit-sparkle`.
   It's the base64 string after "Password:".
2. Set permission: `chmod 0600 ~/.ssh/toolkit-sparkle`
3. Import the key into Keychain: `bin/sparkle/generate_keys --account toolkit -f ~/.ssh/toolkit-sparkle`

## Reset permissions

```
bin/tccutil-reset
```

## Use a custom API endpoint for development

```
defaults write ai.toolkit.mac ToolkitServerHost "https://toolkit-web-git-s3-upload-toolkit-ai.vercel.app"

# Later:
defaults delete ai.toolkit.mac ToolkitServerHost
```
